Copy preopted files from B partition.

This translates from the preopted files in the system_other partition
into the main dalvik-cache. This also has init scripts to allow this
to run.

We first copy to a temporary file before renaming them in order to
make the copy atomic.

Bug: 29278988
Change-Id: I8bf1b2d021998949fd9996a923be7db9691e6a1e
diff --git a/cppreopts/Android.mk b/cppreopts/Android.mk
new file mode 100644
index 0000000..049f2b4
--- /dev/null
+++ b/cppreopts/Android.mk
@@ -0,0 +1,27 @@
+# Copyright 2016 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+LOCAL_PATH:= $(call my-dir)
+
+# Create the cppreopts that does the copy
+include $(CLEAR_VARS)
+
+LOCAL_MODULE:= cppreopts.sh
+LOCAL_MODULE_CLASS := EXECUTABLES
+LOCAL_INIT_RC := cppreopts.rc
+LOCAL_SRC_FILES := cppreopts.sh
+
+LOCAL_REQUIRED_MODULES := preopt2cachename
+
+include $(BUILD_PREBUILT)
diff --git a/cppreopts/cppreopts.rc b/cppreopts/cppreopts.rc
new file mode 100644
index 0000000..3df9148
--- /dev/null
+++ b/cppreopts/cppreopts.rc
@@ -0,0 +1,25 @@
+# Copyright 2016 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+on property:sys.cppreopt=requested && property:ro.boot.slot_suffix=_a
+    mount ext4 /dev/block/bootdevice/by-name/system_b /postinstall ro nosuid nodev noexec
+    exec - root -- /system/bin/cppreopts.sh /postinstall
+    umount /postinstall
+    setprop sys.cppreopt finished
+
+on property:sys.cppreopt=requested && property:ro.boot.slot_suffix=_b
+    mount ext4 /dev/block/bootdevice/by-name/system_a /postinstall ro nosuid nodev noexec
+    exec - root -- /system/bin/cppreopts.sh /postinstall
+    umount /postinstall
+    setprop sys.cppreopt finished
diff --git a/cppreopts/cppreopts.sh b/cppreopts/cppreopts.sh
new file mode 100644
index 0000000..4c72e94
--- /dev/null
+++ b/cppreopts/cppreopts.sh
@@ -0,0 +1,58 @@
+#!/system/bin/sh
+#
+# Copyright (C) 2016 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# create files with 644 (global read) permissions.
+umask 022
+
+if [ $# -ne 1 ]; then
+  log -p e -t cppreopts "Usage: cppreopts <preopts-mount-point>"
+  exit 1
+fi
+
+# Where the system_b is mounted that contains the preopt'd files
+mountpoint=$1
+
+if ! test -f ${mountpoint}/system-other-odex-marker ; then
+  log -p i -t cppreopts "system_other partition does not appear have been built to contain preopted files."
+  exit 1
+fi
+
+log -p i -t cppreopts "cppreopts from ${mountpoint}"
+# For each odex file.
+find ${mountpoint} -type f -name "*.odex" | while read odex_file; do
+  real_odex_name=${odex_file/${mountpoint}/\/system}
+  dest_name=$(preopt2cachename ${real_odex_name})
+  # Move to a temporary file so we can do a rename and have the preopted file
+  # appear atomically in the filesystem.
+  temp_dest_name=${dest_name}.tmp
+  if ! test $? -eq 0 ; then
+    log -p i -t cppreopts "Unable to figure out destination for ${odex_file}"
+    continue
+  fi
+  if ! cp ${odex_file} ${temp_dest_name} ; then
+    log -p w -t cppreopts "Unable to copy odex file ${odex_file} to ${temp_dest_name}!"
+  else
+    log -p i -t cppreopts "Copied odex file from ${odex_file} to ${temp_dest_name}"
+    sync
+    if ! mv ${temp_dest_name} ${dest_name} ; then
+      log -p w -t cppreopts "Unable to rename temporary odex file from ${temp_dest_name} to ${dest_name}"
+    else
+      log -p i -t cppreopts "Renamed temporary odex file from ${temp_dest_name} to ${dest_name}"
+    fi
+  fi
+done
+
+exit 0
diff --git a/preopt2cachename/Android.mk b/preopt2cachename/Android.mk
new file mode 100644
index 0000000..b5a51d9
--- /dev/null
+++ b/preopt2cachename/Android.mk
@@ -0,0 +1,32 @@
+# Copyright 2016 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+LOCAL_PATH:= $(call my-dir)
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE:= preopt2cachename
+
+LOCAL_SRC_FILES := \
+    preopt2cachename.cpp
+
+LOCAL_SHARED_LIBRARIES := \
+    libsysutils \
+    liblog \
+    libcutils \
+    libbase
+
+LOCAL_CFLAGS := -Werror -Wall
+
+include $(BUILD_EXECUTABLE)
diff --git a/preopt2cachename/preopt2cachename.cpp b/preopt2cachename/preopt2cachename.cpp
new file mode 100644
index 0000000..dfdc63f
--- /dev/null
+++ b/preopt2cachename/preopt2cachename.cpp
@@ -0,0 +1,126 @@
+/*
+ * Copyright (C) 2016 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include <iostream>
+
+#include <android-base/logging.h>
+#include <android-base/strings.h>
+
+#ifndef LOG_TAG
+#define LOG_TAG "preopt2cachename"
+#endif
+
+static const char* kDalvikCacheDir = "/data/dalvik-cache/";
+static const char* kCacheSuffix = "@classes.dex";
+
+// Returns the ISA extracted from the odex_file_location.
+// odex_file_location is formatted like /system/app/<app_name>/oat/<isa>/<app_name>.odex for all
+// functions. We return an empty string "" in error cases.
+static std::string ExtractISA(const std::string& odex_file_location) {
+  std::vector<std::string> split_file_location = android::base::Split(odex_file_location, "/");
+  if (split_file_location.size() <= 1) {
+    return "";
+  } else if (split_file_location.size() != 7) {
+    LOG(WARNING) << "Unexpected length for odex-file-location. We expected 7 segments but found "
+                 << split_file_location.size();
+  }
+  return split_file_location[split_file_location.size() - 2];
+}
+
+// Returns the apk name extracted from the odex_file_location.
+// odex_file_location is formatted like /system/app/<app_name>/oat/<isa>/<app_name>.odex. We return
+// the final <app_name> with the .odex replaced with .apk.
+static std::string ExtractAPKName(const std::string& odex_file_location) {
+  // Find and copy filename.
+  size_t file_location_start = odex_file_location.rfind('/');
+  if (file_location_start == std::string::npos) {
+    return "";
+  }
+  size_t ext_start = odex_file_location.rfind('.');
+  if (ext_start == std::string::npos || ext_start < file_location_start) {
+    return "";
+  }
+  std::string apk_name = odex_file_location.substr(file_location_start + 1,
+                                                   ext_start - file_location_start);
+
+  // Replace extension with .apk.
+  apk_name += "apk";
+  return apk_name;
+}
+
+// The cache file name is /data/dalvik-cache/<isa>/ prior to this function
+static bool OdexFilenameToCacheFile(const std::string& odex_file_location,
+                                    /*in-out*/std::string& cache_file) {
+  // Skip the first '/' in odex_file_location.
+  size_t initial_position = odex_file_location[0] == '/' ? 1 : 0;
+  size_t apk_position = odex_file_location.find("/oat", initial_position);
+  if (apk_position == std::string::npos) {
+    LOG(ERROR) << "Unable to find oat directory!";
+    return false;
+  }
+
+  size_t cache_file_position = cache_file.size();
+  cache_file += odex_file_location.substr(initial_position, apk_position);
+  // '/' -> '@' up to where the apk would be.
+  cache_file_position = cache_file.find('/', cache_file_position);
+  while (cache_file_position != std::string::npos) {
+    cache_file[cache_file_position] = '@';
+    cache_file_position = cache_file.find('/', cache_file_position);
+  }
+
+  // Add <apk_name>.
+  std::string apk_name = ExtractAPKName(odex_file_location);
+  if (apk_name.empty()) {
+    LOG(ERROR) << "Unable to determine apk name from odex file name '" << odex_file_location << "'";
+    return false;
+  }
+  cache_file += apk_name;
+  cache_file += kCacheSuffix;
+  return true;
+}
+
+// Do the overall transformation from odex_file_location to output_file_location. Prior to this the
+// output_file_location is empty.
+static bool OdexToCacheFile(std::string& odex_file_location,
+                            /*out*/std::string& output_file_location) {
+  std::string isa = ExtractISA(odex_file_location);
+  if (isa.empty()) {
+    LOG(ERROR) << "Unable to determine isa for odex file '" << odex_file_location << "', skipping";
+    return false;
+  }
+  output_file_location += isa;
+  output_file_location += '/';
+  return OdexFilenameToCacheFile(odex_file_location, output_file_location);
+}
+
+// This program is used to determine where in the /data directory the runtime will search for an
+// odex file if it is unable to find one at the given 'preopt-name' location. This is used to allow
+// us to store these preopted files in the unused system_b partition and copy them out on first
+// boot of the device.
+int main(int argc, char *argv[]) {
+  if (argc != 2) {
+    LOG(ERROR) << "usage: preopt2cachename preopt-location";
+    return 2;
+  }
+  std::string odex_file_location(argv[1]);
+  std::string output_file_location(kDalvikCacheDir);
+  if (!OdexToCacheFile(odex_file_location, output_file_location)) {
+    return 1;
+  } else {
+    std::cout << output_file_location;
+  }
+  return 0;
+}